/// <summary> /// Implement this method as an external command for Revit. /// </summary> /// <param name="commandData">An object that is passed to the external application /// which contains data related to the command, /// such as the application object and active view.</param> /// <param name="message">A message that can be set by the external application /// which will be displayed if a failure or cancellation is returned by /// the external command.</param> /// <param name="elements">A set of elements to which the external application /// can add elements that are to be highlighted in case of failure or cancellation.</param> /// <returns>Return the status of the external command. /// A result of Succeeded means that the API external method functioned as expected. /// Cancelled can be used to signify that the user cancelled the external operation /// at some point. Failure should be returned if the application is unable to proceed with /// the operation.</returns> public Autodesk.Revit.UI.Result Execute(ExternalCommandData commandData, ref string message, ElementSet elements) { try { Autodesk.Revit.DB.ProjectUnit projectUnit = commandData.Application.ActiveUIDocument.Document.ProjectUnit; //prepare data ProjectUnitData dataBuffer = new ProjectUnitData(projectUnit); // show UI using (ProjectUnitForm displayForm = new ProjectUnitForm(dataBuffer)) { DialogResult result = displayForm.ShowDialog(); if (DialogResult.OK != result) { return(Autodesk.Revit.UI.Result.Cancelled); } } return(Autodesk.Revit.UI.Result.Succeeded); } catch (Exception e) { message = e.Message; return(Autodesk.Revit.UI.Result.Failed); } }
/// <summary> /// Initializes a new instance of ProjectUnitData /// </summary> /// <param name="projectUnit">an object of Autodesk.Revit.DB.projectUnit</param> public ProjectUnitData(Autodesk.Revit.DB.ProjectUnit projectUnit) { m_formatOptionList.Clear(); m_projectUnit = projectUnit; foreach (Autodesk.Revit.DB.UnitType unittype in Enum.GetValues(typeof( Autodesk.Revit.DB.UnitType))) { try { Autodesk.Revit.DB.FormatOptions formatOption = m_projectUnit.get_FormatOptions(unittype); } catch (System.Exception /*e*/) { continue; } if (m_projectUnit.get_FormatOptions(unittype) == null) { continue; } m_formatOptionList.Add(m_projectUnit.get_FormatOptions(unittype)); } }